//
//  AppDelegate.swift
//  SettingsExample
//
//  Created by Reid van Melle on 2016-10-30.
//  Copyright © 2016 Reid van Melle. All rights reserved.
//

import UIKit
import QuickSettings

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?

    lazy var settingsVC: UINavigationController = {
        let dataStore = UserDefaults.standard
        let root = QSGroup(title: "Settings Example", children: settings,
                           footer: "Made with a moderate amount of love by a developer who just wants to get stuff done. This library can be used freely without credit.")
        root.initialize(dataStore)
        let vc = QSSettingsViewController(root: root, delegate: self)
        let nav = UINavigationController(rootViewController: vc)
        return nav
    }()

    lazy var signIn: UINavigationController = {
        let vc = SignInViewController()
        let nav = UINavigationController(rootViewController: vc)
        return nav
    }()


    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {

        let tab = UITabBarController()

        tab.viewControllers = [settingsVC, signIn]

        window?.rootViewController = tab
        
        return true
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }

}

extension AppDelegate : QSSettingsViewControllerDelegate {
    func settingsViewController(settingsVc vc: QSSettingsViewController, didUpdateSetting id: String) {
        
    }
}

